/* --- Generated by genom 2.99.31. Do not edit -------------------------- */
/*
 * Copyright (c) 2017-2018 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution  and  use  in  source  and binary  forms,  with  or  without
 * modification, are permitted provided that the following conditions are met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 *
 * THE SOFTWARE  IS PROVIDED "AS IS"  AND THE AUTHOR  DISCLAIMS ALL WARRANTIES
 * WITH  REGARD   TO  THIS  SOFTWARE  INCLUDING  ALL   IMPLIED  WARRANTIES  OF
 * MERCHANTABILITY AND  FITNESS.  IN NO EVENT  SHALL THE AUTHOR  BE LIABLE FOR
 * ANY  SPECIAL, DIRECT,  INDIRECT, OR  CONSEQUENTIAL DAMAGES  OR  ANY DAMAGES
 * WHATSOEVER  RESULTING FROM  LOSS OF  USE, DATA  OR PROFITS,  WHETHER  IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR  OTHER TORTIOUS ACTION, ARISING OUT OF OR
 * IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 *                                           Anthony Mallet on Tue Feb 28 2017
 */

#ifndef H_ARDUIO_CLIENT
#define H_ARDUIO_CLIENT


#include "genom3/c/client.h"


/* --- Interface types ----------------------------------------------------- */





#ifndef _genom_state_stats_c_type
# define _genom_state_stats_c_type
typedef struct genom_state_stats genom_state_stats;
#endif /* _genom_state_stats_c_type */

#ifndef _genom_state_stats_definition_c_type
# define _genom_state_stats_definition_c_type
struct genom_state_stats {
 float last;
 float max;
 float avg;
};
#endif /* _genom_state_stats_definition_c_type */

#include <stdint.h>

#ifndef _genom_state_rusage_c_type
# define _genom_state_rusage_c_type
typedef struct genom_state_rusage genom_state_rusage;
#endif /* _genom_state_rusage_c_type */

#ifndef _genom_state_rusage_definition_c_type
# define _genom_state_rusage_definition_c_type
struct genom_state_rusage {
 uint32_t cycles;
 genom_state_stats timings;
 genom_state_stats load;
};
#endif /* _genom_state_rusage_definition_c_type */

#include <stdint.h>

#ifndef _genom_state_activity_c_type
# define _genom_state_activity_c_type
typedef struct genom_state_activity genom_state_activity;
#endif /* _genom_state_activity_c_type */

#ifndef _genom_state_activity_definition_c_type
# define _genom_state_activity_definition_c_type
struct genom_state_activity {
 uint32_t id;
 char name[64];
};
#endif /* _genom_state_activity_definition_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence_genom_state_activity_c_type
# define _sequence_genom_state_activity_c_type
typedef struct sequence_genom_state_activity {
  uint32_t _maximum, _length;
  genom_state_activity (*_buffer);
  void (*_release)(void *_buffer);
} sequence_genom_state_activity;
#endif /* _sequence_genom_state_activity_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _genom_state_task_c_type
# define _genom_state_task_c_type
typedef struct genom_state_task genom_state_task;
#endif /* _genom_state_task_c_type */

#ifndef _sequence_genom_state_activity_c_type
# define _sequence_genom_state_activity_c_type
typedef struct sequence_genom_state_activity {
  uint32_t _maximum, _length;
  genom_state_activity (*_buffer);
  void (*_release)(void *_buffer);
} sequence_genom_state_activity;
#endif /* _sequence_genom_state_activity_c_type */

#ifndef _genom_state_task_definition_c_type
# define _genom_state_task_definition_c_type
struct genom_state_task {
 char name[64];
 genom_state_rusage rusage;
 sequence_genom_state_activity activity;
};
#endif /* _genom_state_task_definition_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence_genom_state_task_c_type
# define _sequence_genom_state_task_c_type
typedef struct sequence_genom_state_task {
  uint32_t _maximum, _length;
  genom_state_task (*_buffer);
  void (*_release)(void *_buffer);
} sequence_genom_state_task;
#endif /* _sequence_genom_state_task_c_type */




#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _genom_state_component_c_type
# define _genom_state_component_c_type
typedef struct genom_state_component genom_state_component;
#endif /* _genom_state_component_c_type */

#ifndef _sequence_genom_state_task_c_type
# define _sequence_genom_state_task_c_type
typedef struct sequence_genom_state_task {
  uint32_t _maximum, _length;
  genom_state_task (*_buffer);
  void (*_release)(void *_buffer);
} sequence_genom_state_task;
#endif /* _sequence_genom_state_task_c_type */

#ifndef _genom_state_component_definition_c_type
# define _genom_state_component_definition_c_type
struct genom_state_component {
 sequence_genom_state_task task;
 char digest[33];
 char date[31];
 char version[32];
};
#endif /* _genom_state_component_definition_c_type */

#include <stdint.h>

#ifndef _arduio_dir_s_c_type
# define _arduio_dir_s_c_type
typedef uint32_t arduio_dir_s;
enum {
  arduio_IO_IN =	0,
  arduio_IO_IN_PU =	1,
  arduio_IO_OUT =	2,
  arduio_IO_PWM_31kHz =	3,
  arduio_IO_PWM_122Hz =	4,
  arduio_IO_PWM_31Hz =	5,
  arduio_IO_WS28XX =	6
};
#endif /* _arduio_dir_s_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence64_arduio_dir_s_c_type
# define _sequence64_arduio_dir_s_c_type
typedef struct sequence64_arduio_dir_s {
  const uint32_t _maximum;
  uint32_t _length;
  arduio_dir_s _buffer[64];
# ifdef __cplusplus
  sequence64_arduio_dir_s():_maximum(64) {}
  sequence64_arduio_dir_s &operator=(const sequence64_arduio_dir_s &x) {
    _length = x._length;
    for(unsigned i=0; i<_length; i++)
      _buffer[i] = x._buffer[i];
    return *this;
  };
# endif
} sequence64_arduio_dir_s;
#endif /* _sequence64_arduio_dir_s_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence64_float_c_type
# define _sequence64_float_c_type
typedef struct sequence64_float {
  const uint32_t _maximum;
  uint32_t _length;
  float _buffer[64];
# ifdef __cplusplus
  sequence64_float():_maximum(64) {}
  sequence64_float &operator=(const sequence64_float &x) {
    _length = x._length;
    for(unsigned i=0; i<_length; i++)
      _buffer[i] = x._buffer[i];
    return *this;
  };
# endif
} sequence64_float;
#endif /* _sequence64_float_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence16_float_c_type
# define _sequence16_float_c_type
typedef struct sequence16_float {
  const uint32_t _maximum;
  uint32_t _length;
  float _buffer[16];
# ifdef __cplusplus
  sequence16_float():_maximum(16) {}
  sequence16_float &operator=(const sequence16_float &x) {
    _length = x._length;
    for(unsigned i=0; i<_length; i++)
      _buffer[i] = x._buffer[i];
    return *this;
  };
# endif
} sequence16_float;
#endif /* _sequence16_float_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _arduio_state_s_c_type
# define _arduio_state_s_c_type
typedef struct arduio_state_s arduio_state_s;
#endif /* _arduio_state_s_c_type */

#ifndef _sequence64_arduio_dir_s_c_type
# define _sequence64_arduio_dir_s_c_type
typedef struct sequence64_arduio_dir_s {
  const uint32_t _maximum;
  uint32_t _length;
  arduio_dir_s _buffer[64];
# ifdef __cplusplus
  sequence64_arduio_dir_s():_maximum(64) {}
  sequence64_arduio_dir_s &operator=(const sequence64_arduio_dir_s &x) {
    _length = x._length;
    for(unsigned i=0; i<_length; i++)
      _buffer[i] = x._buffer[i];
    return *this;
  };
# endif
} sequence64_arduio_dir_s;
#endif /* _sequence64_arduio_dir_s_c_type */

#ifndef _sequence64_float_c_type
# define _sequence64_float_c_type
typedef struct sequence64_float {
  const uint32_t _maximum;
  uint32_t _length;
  float _buffer[64];
# ifdef __cplusplus
  sequence64_float():_maximum(64) {}
  sequence64_float &operator=(const sequence64_float &x) {
    _length = x._length;
    for(unsigned i=0; i<_length; i++)
      _buffer[i] = x._buffer[i];
    return *this;
  };
# endif
} sequence64_float;
#endif /* _sequence64_float_c_type */

#ifndef _sequence16_float_c_type
# define _sequence16_float_c_type
typedef struct sequence16_float {
  const uint32_t _maximum;
  uint32_t _length;
  float _buffer[16];
# ifdef __cplusplus
  sequence16_float():_maximum(16) {}
  sequence16_float &operator=(const sequence16_float &x) {
    _length = x._length;
    for(unsigned i=0; i<_length; i++)
      _buffer[i] = x._buffer[i];
    return *this;
  };
# endif
} sequence16_float;
#endif /* _sequence16_float_c_type */

#ifndef _arduio_state_s_definition_c_type
# define _arduio_state_s_definition_c_type
struct arduio_state_s {
 sequence64_arduio_dir_s diodir;
 sequence64_float digital;
 sequence16_float analog;
};
#endif /* _arduio_state_s_definition_c_type */


#ifndef _genom_incompatible_digest_client_digest_c_type
# define _genom_incompatible_digest_client_digest_c_type
typedef struct genom_incompatible_digest_client_digest genom_incompatible_digest_client_digest;
#endif /* _genom_incompatible_digest_client_digest_c_type */

#ifndef _genom_incompatible_digest_client_digest_definition_c_type
# define _genom_incompatible_digest_client_digest_definition_c_type
struct genom_incompatible_digest_client_digest {
 char version[32];
 char date[32];
};
#endif /* _genom_incompatible_digest_client_digest_definition_c_type */


#ifndef _genom_incompatible_digest_server_digest_c_type
# define _genom_incompatible_digest_server_digest_c_type
typedef struct genom_incompatible_digest_server_digest genom_incompatible_digest_server_digest;
#endif /* _genom_incompatible_digest_server_digest_c_type */

#ifndef _genom_incompatible_digest_server_digest_definition_c_type
# define _genom_incompatible_digest_server_digest_definition_c_type
struct genom_incompatible_digest_server_digest {
 char version[32];
 char date[32];
};
#endif /* _genom_incompatible_digest_server_digest_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_incompatible_digest_c_type
# define _genom_incompatible_digest_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_incompatible_digest_id[] = "::genom::incompatible_digest";
typedef struct genom_incompatible_digest_detail genom_incompatible_digest_detail;
#endif /* _genom_incompatible_digest_c_type */

#ifndef _genom_incompatible_digest_definition_c_type
# define _genom_incompatible_digest_definition_c_type
struct genom_incompatible_digest_detail {
 genom_incompatible_digest_client_digest client;
 genom_incompatible_digest_server_digest server;
};
static inline genom_event
genom_incompatible_digest(genom_incompatible_digest_detail *d, genom_context self) {
 return self->raise(genom_incompatible_digest_id, d, sizeof(*d), self);
}
#endif /* _genom_incompatible_digest_definition_c_type */


#include "genom3/c/context.h"

#ifndef _genom_bad_transition_c_type
# define _genom_bad_transition_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_bad_transition_id[] = "::genom::bad_transition";
typedef struct genom_bad_transition_detail genom_bad_transition_detail;
#endif /* _genom_bad_transition_c_type */

#ifndef _genom_bad_transition_definition_c_type
# define _genom_bad_transition_definition_c_type
struct genom_bad_transition_detail {
 char from[128];
 char to[128];
};
static inline genom_event
genom_bad_transition(genom_bad_transition_detail *d, genom_context self) {
 return self->raise(genom_bad_transition_id, d, sizeof(*d), self);
}
#endif /* _genom_bad_transition_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_interrupted_c_type
# define _genom_interrupted_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_interrupted_id[] = "::genom::interrupted";
typedef struct genom_interrupted_detail genom_interrupted_detail;
#endif /* _genom_interrupted_c_type */

#ifndef _genom_interrupted_definition_c_type
# define _genom_interrupted_definition_c_type
struct genom_interrupted_detail {
 char by[128];
};
static inline genom_event
genom_interrupted(genom_interrupted_detail *d, genom_context self) {
 return self->raise(genom_interrupted_id, d, sizeof(*d), self);
}
#endif /* _genom_interrupted_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_serialization_c_type
# define _genom_serialization_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_serialization_id[] = "::genom::serialization";
typedef void genom_serialization_detail;
#endif /* _genom_serialization_c_type */

#ifndef _genom_serialization_definition_c_type
# define _genom_serialization_definition_c_type
static inline genom_event
genom_serialization(genom_context self) {
 return self->raise(genom_serialization_id, NULL, 0, self);
}
#endif /* _genom_serialization_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_too_many_activities_c_type
# define _genom_too_many_activities_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_too_many_activities_id[] = "::genom::too_many_activities";
typedef void genom_too_many_activities_detail;
#endif /* _genom_too_many_activities_c_type */

#ifndef _genom_too_many_activities_definition_c_type
# define _genom_too_many_activities_definition_c_type
static inline genom_event
genom_too_many_activities(genom_context self) {
 return self->raise(genom_too_many_activities_id, NULL, 0, self);
}
#endif /* _genom_too_many_activities_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_disallowed_c_type
# define _genom_disallowed_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_disallowed_id[] = "::genom::disallowed";
typedef void genom_disallowed_detail;
#endif /* _genom_disallowed_c_type */

#ifndef _genom_disallowed_definition_c_type
# define _genom_disallowed_definition_c_type
static inline genom_event
genom_disallowed(genom_context self) {
 return self->raise(genom_disallowed_id, NULL, 0, self);
}
#endif /* _genom_disallowed_definition_c_type */


#include "genom3/c/context.h"

#ifndef _genom_mwerr_c_type
# define _genom_mwerr_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_mwerr_id[] = "::genom::mwerr";
typedef struct genom_mwerr_detail genom_mwerr_detail;
#endif /* _genom_mwerr_c_type */

#ifndef _genom_mwerr_definition_c_type
# define _genom_mwerr_definition_c_type
struct genom_mwerr_detail {
 char what[256];
};
static inline genom_event
genom_mwerr(genom_mwerr_detail *d, genom_context self) {
 return self->raise(genom_mwerr_id, d, sizeof(*d), self);
}
#endif /* _genom_mwerr_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_no_such_activity_c_type
# define _genom_no_such_activity_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_no_such_activity_id[] = "::genom::no_such_activity";
typedef void genom_no_such_activity_detail;
#endif /* _genom_no_such_activity_c_type */

#ifndef _genom_no_such_activity_definition_c_type
# define _genom_no_such_activity_definition_c_type
static inline genom_event
genom_no_such_activity(genom_context self) {
 return self->raise(genom_no_such_activity_id, NULL, 0, self);
}
#endif /* _genom_no_such_activity_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_no_such_inport_c_type
# define _genom_no_such_inport_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_no_such_inport_id[] = "::genom::no_such_inport";
typedef void genom_no_such_inport_detail;
#endif /* _genom_no_such_inport_c_type */

#ifndef _genom_no_such_inport_definition_c_type
# define _genom_no_such_inport_definition_c_type
static inline genom_event
genom_no_such_inport(genom_context self) {
 return self->raise(genom_no_such_inport_id, NULL, 0, self);
}
#endif /* _genom_no_such_inport_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_no_such_outport_c_type
# define _genom_no_such_outport_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_no_such_outport_id[] = "::genom::no_such_outport";
typedef void genom_no_such_outport_detail;
#endif /* _genom_no_such_outport_c_type */

#ifndef _genom_no_such_outport_definition_c_type
# define _genom_no_such_outport_definition_c_type
static inline genom_event
genom_no_such_outport(genom_context self) {
 return self->raise(genom_no_such_outport_id, NULL, 0, self);
}
#endif /* _genom_no_such_outport_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_port_io_c_type
# define _genom_port_io_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_port_io_id[] = "::genom::port_io";
typedef void genom_port_io_detail;
#endif /* _genom_port_io_c_type */

#ifndef _genom_port_io_definition_c_type
# define _genom_port_io_definition_c_type
static inline genom_event
genom_port_io(genom_context self) {
 return self->raise(genom_port_io_id, NULL, 0, self);
}
#endif /* _genom_port_io_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_no_such_remote_c_type
# define _genom_no_such_remote_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_no_such_remote_id[] = "::genom::no_such_remote";
typedef void genom_no_such_remote_detail;
#endif /* _genom_no_such_remote_c_type */

#ifndef _genom_no_such_remote_definition_c_type
# define _genom_no_such_remote_definition_c_type
static inline genom_event
genom_no_such_remote(genom_context self) {
 return self->raise(genom_no_such_remote_id, NULL, 0, self);
}
#endif /* _genom_no_such_remote_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_no_such_service_c_type
# define _genom_no_such_service_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_no_such_service_id[] = "::genom::no_such_service";
typedef void genom_no_such_service_detail;
#endif /* _genom_no_such_service_c_type */

#ifndef _genom_no_such_service_definition_c_type
# define _genom_no_such_service_definition_c_type
static inline genom_event
genom_no_such_service(genom_context self) {
 return self->raise(genom_no_such_service_id, NULL, 0, self);
}
#endif /* _genom_no_such_service_definition_c_type */

#include "genom3/c/context.h"

#ifndef _genom_remote_io_c_type
# define _genom_remote_io_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak genom_remote_io_id[] = "::genom::remote_io";
typedef void genom_remote_io_detail;
#endif /* _genom_remote_io_c_type */

#ifndef _genom_remote_io_definition_c_type
# define _genom_remote_io_definition_c_type
static inline genom_event
genom_remote_io(genom_context self) {
 return self->raise(genom_remote_io_id, NULL, 0, self);
}
#endif /* _genom_remote_io_definition_c_type */


#include <stdint.h>
#include "genom3/c/context.h"

#ifndef _arduio_e_sys_c_type
# define _arduio_e_sys_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak arduio_e_sys_id[] = "::arduio::e_sys";
typedef struct arduio_e_sys_detail arduio_e_sys_detail;
#endif /* _arduio_e_sys_c_type */

#ifndef _arduio_e_sys_definition_c_type
# define _arduio_e_sys_definition_c_type
struct arduio_e_sys_detail {
 int16_t code;
 char what[128];
};
static inline genom_event
arduio_e_sys(arduio_e_sys_detail *d, genom_context self) {
 return self->raise(arduio_e_sys_id, d, sizeof(*d), self);
}
#endif /* _arduio_e_sys_definition_c_type */

#include "genom3/c/context.h"

#ifndef _arduio_e_baddev_c_type
# define _arduio_e_baddev_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak arduio_e_baddev_id[] = "::arduio::e_baddev";
typedef struct arduio_e_baddev_detail arduio_e_baddev_detail;
#endif /* _arduio_e_baddev_c_type */

#ifndef _arduio_e_baddev_definition_c_type
# define _arduio_e_baddev_definition_c_type
struct arduio_e_baddev_detail {
 char dev[256];
};
static inline genom_event
arduio_e_baddev(arduio_e_baddev_detail *d, genom_context self) {
 return self->raise(arduio_e_baddev_id, d, sizeof(*d), self);
}
#endif /* _arduio_e_baddev_definition_c_type */


#include "genom3/c/context.h"

#ifndef _arduio_e_baddir_c_type
# define _arduio_e_baddir_c_type
#include "genom3/c/exception.h"
const char genom_extern_weak arduio_e_baddir_id[] = "::arduio::e_baddir";
typedef void arduio_e_baddir_detail;
#endif /* _arduio_e_baddir_c_type */

#ifndef _arduio_e_baddir_definition_c_type
# define _arduio_e_baddir_definition_c_type
static inline genom_event
arduio_e_baddir(genom_context self) {
 return self->raise(arduio_e_baddir_id, NULL, 0, self);
}
#endif /* _arduio_e_baddir_definition_c_type */

#include <stdint.h>
#include "genom3/c/idlsequence.h"

#ifndef _sequence53_float_c_type
# define _sequence53_float_c_type
typedef struct sequence53_float {
  const uint32_t _maximum;
  uint32_t _length;
  float _buffer[53];
# ifdef __cplusplus
  sequence53_float():_maximum(53) {}
  sequence53_float &operator=(const sequence53_float &x) {
    _length = x._length;
    for(unsigned i=0; i<_length; i++)
      _buffer[i] = x._buffer[i];
    return *this;
  };
# endif
} sequence53_float;
#endif /* _sequence53_float_c_type */



/* --- Service input and output structures --------------------------------- */


/* input of abort_activity */
struct genom_arduio_abort_activity_input {
  uint32_t activity;
};

/* output of abort_activity */
struct genom_arduio_abort_activity_output {
};


/* input of connect_port */
struct genom_arduio_connect_port_input {
  char local[128];
  char remote[128];
};

/* output of connect_port */
struct genom_arduio_connect_port_output {
};


/* input of connect_service */
struct genom_arduio_connect_service_input {
  char local[128];
  char remote[128];
};

/* output of connect_service */
struct genom_arduio_connect_service_output {
};


/* input of kill */
struct genom_arduio_kill_input {
};

/* output of kill */
struct genom_arduio_kill_output {
};


/* input of connect */
struct genom_arduio_connect_input {
  char serial[64];
};

/* output of connect */
struct genom_arduio_connect_output {
};


/* input of disconnect */
struct genom_arduio_disconnect_input {
};

/* output of disconnect */
struct genom_arduio_disconnect_output {
};


/* input of set_dir */
struct genom_arduio_set_dir_input {
  uint8_t n;
  arduio_dir_s dir;
};

/* output of set_dir */
struct genom_arduio_set_dir_output {
};


/* input of out1 */
struct genom_arduio_out1_input {
  uint8_t n;
  float value;
};

/* output of out1 */
struct genom_arduio_out1_output {
};


/* input of out */
struct genom_arduio_out_input {
  sequence53_float values;
};

/* output of out */
struct genom_arduio_out_output {
};



#ifdef __cplusplus
extern "C" {
#endif

/* --- Services ------------------------------------------------------------ */

genom_client		genom_arduio_client_init(int argc, char *argv[],
                                genom_event *ex, const void **exdetail);
void			genom_arduio_client_fini(genom_client h);
genom_context		genom_arduio_client_context(genom_client h);
const char *		genom_arduio_client_instance(genom_client h);
int			genom_arduio_client_eventfd(genom_client h);
const struct genom_service_info *
			genom_arduio_client_service_info(genom_client h,
				int rqstid);
int			genom_arduio_client_done(genom_client h, int rqstid);
genom_event		genom_arduio_client_wait(genom_client h, int rqstid);
genom_event		genom_arduio_client_clean(genom_client h,
				int rqstid);
genom_event		genom_arduio_client_abort(genom_client h,
                                int rqstid);
genom_event		genom_arduio_client_doevents(genom_client h);
char *			genom_arduio_client_json_error(genom_client h,
				genom_event e, const void *detail);

/* abort_activity */
typedef void (*arduio_abort_activity_cb)(
  genom_client h,
  int rqstid,
  genom_event report,
  struct genom_arduio_abort_activity_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_arduio_client_abort_activity_rqst(
  genom_client h,
  const struct genom_arduio_abort_activity_input *in,
  arduio_abort_activity_cb sentcb, arduio_abort_activity_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_arduio_client_abort_activity_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_arduio_abort_activity_output **out,
  void **exdetail);

void	genom_arduio_client_abort_activity_init_input(
  struct genom_arduio_abort_activity_input *input);
void	genom_arduio_client_abort_activity_init_output(
  struct genom_arduio_abort_activity_output *output);
void	genom_arduio_client_abort_activity_fini_input(
  struct genom_arduio_abort_activity_input *input);
void	genom_arduio_client_abort_activity_fini_output(
  struct genom_arduio_abort_activity_output *output);

int	genom_arduio_client_abort_activity_json_scan(
  struct genom_arduio_abort_activity_input *in,
  const char *json, char **endptr);
int	genom_arduio_client_abort_activity_json_print(
  char **json, const struct genom_arduio_abort_activity_output *out);

/* connect_port */
typedef void (*arduio_connect_port_cb)(
  genom_client h,
  int rqstid,
  genom_event report,
  struct genom_arduio_connect_port_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_arduio_client_connect_port_rqst(
  genom_client h,
  const struct genom_arduio_connect_port_input *in,
  arduio_connect_port_cb sentcb, arduio_connect_port_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_arduio_client_connect_port_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_arduio_connect_port_output **out,
  void **exdetail);

void	genom_arduio_client_connect_port_init_input(
  struct genom_arduio_connect_port_input *input);
void	genom_arduio_client_connect_port_init_output(
  struct genom_arduio_connect_port_output *output);
void	genom_arduio_client_connect_port_fini_input(
  struct genom_arduio_connect_port_input *input);
void	genom_arduio_client_connect_port_fini_output(
  struct genom_arduio_connect_port_output *output);

int	genom_arduio_client_connect_port_json_scan(
  struct genom_arduio_connect_port_input *in,
  const char *json, char **endptr);
int	genom_arduio_client_connect_port_json_print(
  char **json, const struct genom_arduio_connect_port_output *out);

/* connect_service */
typedef void (*arduio_connect_service_cb)(
  genom_client h,
  int rqstid,
  genom_event report,
  struct genom_arduio_connect_service_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_arduio_client_connect_service_rqst(
  genom_client h,
  const struct genom_arduio_connect_service_input *in,
  arduio_connect_service_cb sentcb, arduio_connect_service_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_arduio_client_connect_service_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_arduio_connect_service_output **out,
  void **exdetail);

void	genom_arduio_client_connect_service_init_input(
  struct genom_arduio_connect_service_input *input);
void	genom_arduio_client_connect_service_init_output(
  struct genom_arduio_connect_service_output *output);
void	genom_arduio_client_connect_service_fini_input(
  struct genom_arduio_connect_service_input *input);
void	genom_arduio_client_connect_service_fini_output(
  struct genom_arduio_connect_service_output *output);

int	genom_arduio_client_connect_service_json_scan(
  struct genom_arduio_connect_service_input *in,
  const char *json, char **endptr);
int	genom_arduio_client_connect_service_json_print(
  char **json, const struct genom_arduio_connect_service_output *out);

/* kill */
typedef void (*arduio_kill_cb)(
  genom_client h,
  int rqstid,
  genom_event report,
  struct genom_arduio_kill_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_arduio_client_kill_rqst(
  genom_client h,
  const struct genom_arduio_kill_input *in,
  arduio_kill_cb sentcb, arduio_kill_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_arduio_client_kill_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_arduio_kill_output **out,
  void **exdetail);

void	genom_arduio_client_kill_init_input(
  struct genom_arduio_kill_input *input);
void	genom_arduio_client_kill_init_output(
  struct genom_arduio_kill_output *output);
void	genom_arduio_client_kill_fini_input(
  struct genom_arduio_kill_input *input);
void	genom_arduio_client_kill_fini_output(
  struct genom_arduio_kill_output *output);

int	genom_arduio_client_kill_json_scan(
  struct genom_arduio_kill_input *in,
  const char *json, char **endptr);
int	genom_arduio_client_kill_json_print(
  char **json, const struct genom_arduio_kill_output *out);

/* connect */
typedef void (*arduio_connect_cb)(
  genom_client h,
  int rqstid,
  genom_event report,
  struct genom_arduio_connect_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_arduio_client_connect_rqst(
  genom_client h,
  const struct genom_arduio_connect_input *in,
  arduio_connect_cb sentcb, arduio_connect_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_arduio_client_connect_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_arduio_connect_output **out,
  void **exdetail);

void	genom_arduio_client_connect_init_input(
  struct genom_arduio_connect_input *input);
void	genom_arduio_client_connect_init_output(
  struct genom_arduio_connect_output *output);
void	genom_arduio_client_connect_fini_input(
  struct genom_arduio_connect_input *input);
void	genom_arduio_client_connect_fini_output(
  struct genom_arduio_connect_output *output);

int	genom_arduio_client_connect_json_scan(
  struct genom_arduio_connect_input *in,
  const char *json, char **endptr);
int	genom_arduio_client_connect_json_print(
  char **json, const struct genom_arduio_connect_output *out);

/* disconnect */
typedef void (*arduio_disconnect_cb)(
  genom_client h,
  int rqstid,
  genom_event report,
  struct genom_arduio_disconnect_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_arduio_client_disconnect_rqst(
  genom_client h,
  const struct genom_arduio_disconnect_input *in,
  arduio_disconnect_cb sentcb, arduio_disconnect_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_arduio_client_disconnect_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_arduio_disconnect_output **out,
  void **exdetail);

void	genom_arduio_client_disconnect_init_input(
  struct genom_arduio_disconnect_input *input);
void	genom_arduio_client_disconnect_init_output(
  struct genom_arduio_disconnect_output *output);
void	genom_arduio_client_disconnect_fini_input(
  struct genom_arduio_disconnect_input *input);
void	genom_arduio_client_disconnect_fini_output(
  struct genom_arduio_disconnect_output *output);

int	genom_arduio_client_disconnect_json_scan(
  struct genom_arduio_disconnect_input *in,
  const char *json, char **endptr);
int	genom_arduio_client_disconnect_json_print(
  char **json, const struct genom_arduio_disconnect_output *out);

/* set_dir */
typedef void (*arduio_set_dir_cb)(
  genom_client h,
  int rqstid,
  genom_event report,
  struct genom_arduio_set_dir_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_arduio_client_set_dir_rqst(
  genom_client h,
  const struct genom_arduio_set_dir_input *in,
  arduio_set_dir_cb sentcb, arduio_set_dir_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_arduio_client_set_dir_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_arduio_set_dir_output **out,
  void **exdetail);

void	genom_arduio_client_set_dir_init_input(
  struct genom_arduio_set_dir_input *input);
void	genom_arduio_client_set_dir_init_output(
  struct genom_arduio_set_dir_output *output);
void	genom_arduio_client_set_dir_fini_input(
  struct genom_arduio_set_dir_input *input);
void	genom_arduio_client_set_dir_fini_output(
  struct genom_arduio_set_dir_output *output);

int	genom_arduio_client_set_dir_json_scan(
  struct genom_arduio_set_dir_input *in,
  const char *json, char **endptr);
int	genom_arduio_client_set_dir_json_print(
  char **json, const struct genom_arduio_set_dir_output *out);

/* out1 */
typedef void (*arduio_out1_cb)(
  genom_client h,
  int rqstid,
  genom_event report,
  struct genom_arduio_out1_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_arduio_client_out1_rqst(
  genom_client h,
  const struct genom_arduio_out1_input *in,
  arduio_out1_cb sentcb, arduio_out1_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_arduio_client_out1_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_arduio_out1_output **out,
  void **exdetail);

void	genom_arduio_client_out1_init_input(
  struct genom_arduio_out1_input *input);
void	genom_arduio_client_out1_init_output(
  struct genom_arduio_out1_output *output);
void	genom_arduio_client_out1_fini_input(
  struct genom_arduio_out1_input *input);
void	genom_arduio_client_out1_fini_output(
  struct genom_arduio_out1_output *output);

int	genom_arduio_client_out1_json_scan(
  struct genom_arduio_out1_input *in,
  const char *json, char **endptr);
int	genom_arduio_client_out1_json_print(
  char **json, const struct genom_arduio_out1_output *out);

/* out */
typedef void (*arduio_out_cb)(
  genom_client h,
  int rqstid,
  genom_event report,
  struct genom_arduio_out_output *out,
  const void *exdetail,
  void *cb_data);

genom_event genom_arduio_client_out_rqst(
  genom_client h,
  const struct genom_arduio_out_input *in,
  arduio_out_cb sentcb, arduio_out_cb donecb,
  void *cb_data, int *rqstid);

genom_event genom_arduio_client_out_result(
  genom_client h, int rqstid, genom_event *report,
  struct genom_arduio_out_output **out,
  void **exdetail);

void	genom_arduio_client_out_init_input(
  struct genom_arduio_out_input *input);
void	genom_arduio_client_out_init_output(
  struct genom_arduio_out_output *output);
void	genom_arduio_client_out_fini_input(
  struct genom_arduio_out_input *input);
void	genom_arduio_client_out_fini_output(
  struct genom_arduio_out_output *output);

int	genom_arduio_client_out_json_scan(
  struct genom_arduio_out_input *in,
  const char *json, char **endptr);
int	genom_arduio_client_out_json_print(
  char **json, const struct genom_arduio_out_output *out);



/* --- Ports --------------------------------------------------------------- */

/* genom_state */
#line 78 "/opt/openrobots/share/genom/templates/common/genom.gen"
genom_event genom_arduio_client_genom_state_port(
  genom_client h,
  genom_state_component *data);

/* ios */
#line 63 "/local/robotpkg/var/tmp/robotpkg/sysutils/arduio-genom3/work/arduio-genom3-1.3/arduio.gen"
genom_event genom_arduio_client_ios_port(
  genom_client h,
  arduio_state_s *data);


void	genom_arduio_client_genom_state_init_data(
  genom_state_component *data);
void	genom_arduio_client_genom_state_fini_data(
  genom_state_component *data);
int	genom_arduio_client_genom_state_json_print(char **json,
  const genom_state_component *data);

void	genom_arduio_client_ios_init_data(
  arduio_state_s *data);
void	genom_arduio_client_ios_fini_data(
  arduio_state_s *data);
int	genom_arduio_client_ios_json_print(char **json,
  const arduio_state_s *data);




/* --- Data ---------------------------------------------------------------- */

extern const struct genom_client_info genom_arduio_client_info;

extern const struct genom_service_info *
			genom_arduio_client_abort_activity_info;
extern const struct genom_service_info *
			genom_arduio_client_connect_port_info;
extern const struct genom_service_info *
			genom_arduio_client_connect_service_info;
extern const struct genom_service_info *
			genom_arduio_client_kill_info;
extern const struct genom_service_info *
			genom_arduio_client_connect_info;
extern const struct genom_service_info *
			genom_arduio_client_disconnect_info;
extern const struct genom_service_info *
			genom_arduio_client_set_dir_info;
extern const struct genom_service_info *
			genom_arduio_client_out1_info;
extern const struct genom_service_info *
			genom_arduio_client_out_info;

extern const struct genom_port_info *
			genom_arduio_client_genom_state_info;
extern const struct genom_port_info *
			genom_arduio_client_ios_info;

#ifdef __cplusplus
}
#endif

#endif /* H_ARDUIO_CLIENT */
